
#ifndef COMPRESS_HPP
#define COMPRESS_HPP

#if defined(__DOS16__) || defined(__OS2__)
#define __PKWARE__
int zip_implode(
  unsigned (*_reader)(void *buf,unsigned size),
  unsigned (*_writer)(void *buf,unsigned size));

int zip_explode(
  unsigned (*_reader)(void *buf,unsigned size),
  unsigned (*_writer)(void *buf,unsigned size));
#endif

int zip_deflate(
  unsigned (*_reader)(void *buf,unsigned size),
  unsigned (*_writer)(void *buf,unsigned size));

int zip_inflate(
  unsigned (*_reader)(void *buf,unsigned size),
  unsigned (*_writer)(void *buf,unsigned size));

//#define ZIP_OK    0
//#define ZIP_NOMEM 1 // no memory, allocated memory isn't freed

int process_zipfile(const char *zipfile,    /* return PK-type error code */
                    int (*_callback)(void *ud,
                                     long offset,
                                     int method,
                                     unsigned long csize,
                                     unsigned long ucsize,
                                     unsigned long attributes,
                                     const char *filename),
                    void *ud);
#define PK_OK             0    /* no error */
#define PK_WARN           1    /* for zip_process - Warning (fnf in arch, etc) */
#define PK_INTERR         1    /* EXTERNAL ONLY - Incomplete (deflate) */
#define PK_ERR            2    /* error in zipfile (unpack) */
#define PK_MEM            3    /* insufficient memory */
#define PK_WEOF           4    /* EOF or error in write (ONLY PACKED!)*/
#define PK_REOF           5    /* EOF or error in read */
#define PK_ZFERR          6    /* ERROR for explode (read or structure)  */
// next for process_zip_file ONLY
#define PK_BADERR         8    /* severe error in zipfile (e.g. central dir) */
#define PK_NOZIP          9    /* zipfile not found */
#define IZ_DIR            76   /* potential zipfile is a directory */

#define STORED            0    /* compression methods */
#define SHRUNK            1
#define REDUCED1          2
#define REDUCED2          3
#define REDUCED3          4
#define REDUCED4          5
#define IMPLODED          6
#define TOKENIZED         7
#define DEFLATED          8
#define NUM_METHODS       9    /* index of last method + 1 */

#endif
