#include "../common.cpp"

//-----------------------------------------------------------------------
size_t cdecl strlen(const char *str)
{
  int cnt = 0;
  while ( *str++ ) cnt++;
  return cnt;
}

//-----------------------------------------------------------------------
char *cdecl strchr(char *str, int c)
{
  while ( *str != c )
  {
    if ( *str == '\0' ) return NULL;
    str++;
  }
  return str;
}


//-----------------------------------------------------------------------
void _FAR * _RTLENTRYF _EXPFUNC memset(void _FAR *ptr, int c, size_t size)
{
  char *p = (char*)ptr;
  while ( size > 0 ) (*p++ = uchar(c)), size--;
  return ptr;
}

//-----------------------------------------------------------------------
void _FAR * _RTLENTRY  _EXPFUNC memcpy(void _FAR *__dest, const void _FAR *__src,
                                       size_t __n)
{
  char *d = (char *)__dest;
  char *s = (char *)__src;
  while ( __n > 0 )
  {
    *d++ = *s++;
    __n--;
  }
  return __dest;
}                                       

//-----------------------------------------------------------------------
void  _FAR *_RTLENTRY calloc(size_t nitems, size_t size)
{
  size *= nitems;
  void *ptr = malloc(size);
  if ( ptr != NULL ) memset(ptr, 0, size);
  return ptr;
}

//-----------------------------------------------------------------------
void        _RTLENTRY free(void _FAR *)
{
  // do nothing...
}

//-----------------------------------------------------------------------
void  _FAR *_RTLENTRY malloc(size_t size)
{
  HANDLE hm = LocalAlloc(LMEM_MOVEABLE, size);
  if ( hm == NULL ) return NULL;
  return LocalLock(hm);
}
