// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'DropTarget.pas' rev: 4.00

#ifndef DropTargetHPP
#define DropTargetHPP

#pragma delphiheader begin
#pragma option push -w-
#include <Graphics.hpp>	// Pascal unit
#include <ExtCtrls.hpp>	// Pascal unit
#include <Commctrl.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <DropSource.hpp>	// Pascal unit
#include <Clipbrd.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <ShellAPI.hpp>	// Pascal unit
#include <ShlObj.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <ActiveX.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Droptarget
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TScrollDirection { sdHorizontal, sdVertical };
#pragma option pop

typedef Set<TScrollDirection, sdHorizontal, sdVertical>  TScrollDirections;

typedef void __fastcall (__closure *TDropTargetEvent)(System::TObject* Sender, Classes::TShiftState 
	ShiftState, const Windows::TPoint &Point, int &Effect);

class DELPHICLASS TDropTarget;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TDropTarget : public Dropsource::TInterfacedComponent 
{
	typedef Dropsource::TInterfacedComponent inherited;
	
private:
	_di_IDataObject fDataObj;
	Dropsource::TDragTypes fDragTypes;
	bool fRegistered;
	Controls::TWinControl* fTarget;
	bool fGetDataOnEnter;
	TDropTargetEvent fOnEnter;
	TDropTargetEvent fOnDragOver;
	Classes::TNotifyEvent fOnLeave;
	TDropTargetEvent fOnDrop;
	TDropTargetEvent fGetDropEffectEvent;
	Controls::TImageList* fImages;
	unsigned fDragImageHandle;
	bool fShowImage;
	Windows::TPoint fImageHotSpot;
	Windows::TPoint fLastPoint;
	int fTargetScrollMargin;
	TScrollDirections fScrollDirs;
	Extctrls::TTimer* fScrollTimer;
	void __fastcall DoTargetScroll(System::TObject* Sender);
	void __fastcall SetTarget(Controls::TWinControl* Target);
	
protected:
	HRESULT __stdcall DragEnter(const _di_IDataObject DataObj, int grfKeyState, const Windows::TPoint pt
		, int &dwEffect);
	HRESULT __stdcall DragOver(int grfKeyState, const Windows::TPoint pt, int &dwEffect);
	HRESULT __stdcall DragLeave(void);
	HRESULT __stdcall Drop(const _di_IDataObject dataObj, int grfKeyState, const Windows::TPoint pt, int 
		&dwEffect);
	virtual bool __fastcall DoGetData(void) = 0 ;
	virtual void __fastcall ClearData(void) = 0 ;
	virtual bool __fastcall HasValidFormats(void) = 0 ;
	virtual int __fastcall GetValidDropEffect(Classes::TShiftState ShiftState, const Windows::TPoint &pt
		, int dwEffect);
	
public:
	__fastcall virtual TDropTarget(Classes::TComponent* AOwner);
	__fastcall virtual ~TDropTarget(void);
	void __fastcall Register(Controls::TWinControl* Target);
	void __fastcall Unregister(void);
	virtual int __fastcall PasteFromClipboard(void);
	__property _di_IDataObject DataObject = {read=fDataObj};
	__property Controls::TWinControl* Target = {read=fTarget, write=SetTarget};
	
__published:
	__property Dropsource::TDragTypes Dragtypes = {read=fDragTypes, write=fDragTypes, nodefault};
	__property bool GetDataOnEnter = {read=fGetDataOnEnter, write=fGetDataOnEnter, nodefault};
	__property TDropTargetEvent OnEnter = {read=fOnEnter, write=fOnEnter};
	__property TDropTargetEvent OnDragOver = {read=fOnDragOver, write=fOnDragOver};
	__property Classes::TNotifyEvent OnLeave = {read=fOnLeave, write=fOnLeave};
	__property TDropTargetEvent OnDrop = {read=fOnDrop, write=fOnDrop};
	__property TDropTargetEvent OnGetDropEffect = {read=fGetDropEffectEvent, write=fGetDropEffectEvent}
		;
	__property bool ShowImage = {read=fShowImage, write=fShowImage, nodefault};
private:
	void *__IDropTarget;	/* IDropTarget */
	
public:
	operator IDropTarget*(void) { return (IDropTarget*)&__IDropTarget; }
	
};

#pragma pack(pop)

class DELPHICLASS TDropFileTarget;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TDropFileTarget : public TDropTarget 
{
	typedef TDropTarget inherited;
	
private:
	Classes::TStrings* fFiles;
	Classes::TStrings* fMappedNames;
	tagFORMATETC fFileNameMapFormatEtc;
	tagFORMATETC fFileNameMapWFormatEtc;
	
protected:
	virtual void __fastcall ClearData(void);
	virtual bool __fastcall DoGetData(void);
	virtual bool __fastcall HasValidFormats(void);
	
public:
	__fastcall virtual TDropFileTarget(Classes::TComponent* AOwner);
	__fastcall virtual ~TDropFileTarget(void);
	virtual int __fastcall PasteFromClipboard(void);
	__property Classes::TStrings* Files = {read=fFiles};
	__property Classes::TStrings* MappedNames = {read=fMappedNames};
};

#pragma pack(pop)

class DELPHICLASS TDropTextTarget;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TDropTextTarget : public TDropTarget 
{
	typedef TDropTarget inherited;
	
private:
	AnsiString fText;
	
protected:
	virtual void __fastcall ClearData(void);
	virtual bool __fastcall DoGetData(void);
	virtual bool __fastcall HasValidFormats(void);
	
public:
	virtual int __fastcall PasteFromClipboard(void);
	__property AnsiString Text = {read=fText, write=fText};
public:
	#pragma option push -w-inl
	/* TDropTarget.Create */ inline __fastcall virtual TDropTextTarget(Classes::TComponent* AOwner) : TDropTarget(
		AOwner) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TDropTarget.Destroy */ inline __fastcall virtual ~TDropTextTarget(void) { }
	#pragma option pop
	
};

#pragma pack(pop)

class DELPHICLASS TDropDummy;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TDropDummy : public TDropTarget 
{
	typedef TDropTarget inherited;
	
protected:
	virtual void __fastcall ClearData(void);
	virtual bool __fastcall DoGetData(void);
	virtual bool __fastcall HasValidFormats(void);
public:
	#pragma option push -w-inl
	/* TDropTarget.Create */ inline __fastcall virtual TDropDummy(Classes::TComponent* AOwner) : TDropTarget(
		AOwner) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TDropTarget.Destroy */ inline __fastcall virtual ~TDropDummy(void) { }
	#pragma option pop
	
};

#pragma pack(pop)

//-- var, const, procedure ---------------------------------------------------
extern PACKAGE tagFORMATETC HDropFormatEtc;
extern PACKAGE tagFORMATETC TextFormatEtc;
extern PACKAGE void __fastcall Register(void);
extern PACKAGE Windows::TPoint __fastcall ClientPtToWindowPt(HWND Handle, const Windows::TPoint &pt)
	;
extern PACKAGE bool __fastcall GetFilesFromHGlobal(const unsigned HGlob, Classes::TStrings* &Files);
	

}	/* namespace Droptarget */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Droptarget;
#endif
#pragma option pop	// -w-

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// DropTarget
