//---------------------------------------------------------------------------
#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <FileCtrl.hpp>
#include "cdiroutl.h"
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <Grids.hpp>
#include <Outline.hpp>
#include <Dialogs.hpp>
#include <ActnList.hpp>
#include <Menus.hpp>
#include <ImgList.hpp>
#include <ExtCtrls.hpp>
#include <Graphics.hpp>
#include "DropSource.hpp"

//---------------------------------------------------------------------------
const int WM_SENTFILES   = WM_USER;
const int WM_TRAYNOTIFY  = WM_USER + 1001;

//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
        TListView *ListView1;
        TBitBtn *BitBtn1;
        TBitBtn *BitBtn2;
        TOpenDialog *OpenDialog1;
        TMainMenu *MainMenu1;
        TMenuItem *Broswe1;
        TMenuItem *Configure1;
        TMenuItem *Help1;
        TActionList *ActionList1;
        TAction *Browse;
        TAction *Configure;
        TAction *Help;
        TImageList *ImageList1;
        TMenuItem *LargeIcons1;
        TMenuItem *SmallIcons1;
        TMenuItem *List1;
        TMenuItem *Details1;
        TAction *LargeIcon;
        TAction *SmallIcon;
        TAction *Details;
        TAction *List;
        TImageList *ImageList2;
        TPopupMenu *PopupMenu1;
        TMenuItem *View1;
        TMenuItem *N1;
        TMenuItem *LargeIcons2;
        TMenuItem *SmallIcons2;
        TMenuItem *List2;
        TMenuItem *Details2;
        TMenuItem *Sendto1;
        TMenuItem *Delete1;
        TMenuItem *Rename1;
        TAction *SendTo;
        TAction *Delete;
        TAction *Rename;
        TImage *ListBack;
        TDropFileSource *DropFileSource1;
        TMenuItem *N2;
        TAction *Options;
        TMenuItem *Options1;
        TImage *FormBack;
        TPopupMenu *TrayMenu;
        TMenuItem *Browse1;
        TMenuItem *Options2;
        TAction *Exit;
        TMenuItem *Exit1;
        TAction *www;
        TMenuItem *www1;
        TMenuItem *N3;
        TMenuItem *N4;
        TImage *Image1;
        void __fastcall BrowseExecute(TObject *Sender);
        void __fastcall HelpExecute(TObject *Sender);
        void __fastcall Label1Click(TObject *Sender);
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall LargeIconExecute(TObject *Sender);
        void __fastcall SmallIconExecute(TObject *Sender);
        void __fastcall DetailsExecute(TObject *Sender);
        void __fastcall ListExecute(TObject *Sender);
        void __fastcall DeleteExecute(TObject *Sender);
        void __fastcall RenameExecute(TObject *Sender);
        void __fastcall ListView1SelectItem(TObject *Sender,
          TListItem *Item, bool Selected);
        void __fastcall ListView1DragOver(TObject *Sender, TObject *Source,
          int X, int Y, TDragState State, bool &Accept);
        void __fastcall ListView1CustomDraw(TCustomListView *Sender,
          const TRect &ARect, bool &DefaultDraw);
        void __fastcall ListView1Edited(TObject *Sender, TListItem *Item,
          AnsiString &S);
        void __fastcall ListView1MouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
        void __fastcall ListView1DblClick(TObject *Sender);
        void __fastcall OptionsExecute(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall ExitExecute(TObject *Sender);
        void __fastcall wwwExecute(TObject *Sender);
        void __fastcall ListView1Resize(TObject *Sender);
        void __fastcall ListView1Editing(TObject *Sender, TListItem *Item,
          bool &AllowEdit);
        bool __fastcall FormHelp(WORD Command, int Data, bool &CallHelp);
private:	// User declarations
        void __fastcall populate_images(void);
        void __fastcall AppOnMessage(TMsg &Msg, bool &handled);
        void __fastcall WMTrayNotify(TMessage &Msg);
        void __fastcall WMSentFiles(TMessage &Msg);
        char *__fastcall get_current_files(void);
        Graphics::TIcon *TrayIcon;
        void __fastcall RemoveIcon();
        void __fastcall AddIcon();

        TShortCut saved_del;

public:		// User declarations
        __fastcall TForm1(TComponent* Owner);
        __fastcall ~TForm1(void);
        void __fastcall populate_list(const char *folder);

BEGIN_MESSAGE_MAP
     MESSAGE_HANDLER(WM_SENTFILES, TMessage,WMSentFiles)
     MESSAGE_HANDLER(WM_TRAYNOTIFY,TMessage,WMTrayNotify)
END_MESSAGE_MAP(TForm)

};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;

void write_config(bool remember, DWORD ctray, const char *phrase);
void read_config(bool *remember, char *phrase);
bool cfg_folder(const char *folder);
bool cfg_position(int left, int top, int width, int height);
void read_cfg_position(void);
void correct_autorun(bool use);
void correct_sendto(bool use);
bool sendto_present(void);
bool autorun_present(void);
void registry_error(void);
bool encrypt(char *files);

void provide_help(void);

extern HANDLE mail;
extern char encrypted_folder[];
extern DWORD ctray;           // tray on close
extern ulong scrc32;
extern bool config_ok;

//---------------------------------------------------------------------------
#endif
