#include <windows.h>
#include "zip.h"
#include "fish.h"
#include "compress.hpp"

static int verbose = 0;
static int level = 6;
static unsigned (*read_buf) OF((void *buf, unsigned size));

#include "deflate.cpp"
#include "trees.cpp"
#include "bits.cpp"

static unsigned (*write_buf)(void *buf,unsigned size);

static unsigned zfwrite(voidp *buf,extent item_size,extent nb) {
  return write_buf(buf,item_size*nb);
}

int zip_deflate(
  unsigned (*file_read)(void *buf, unsigned size),
  unsigned (*file_write)(void *buf,unsigned size)) {
  read_buf = file_read;
  write_buf = file_write;
  unsigned short flags = 0;
  lm_zero();
  bi_init(NULL);
  unsigned short att = UNKNOWN;
  int m;                /* method for this entry */
  m = DEFLATE;
  if ( !ct_init(&att, &m)     ) return PK_MEM;
  if ( !lm_init(level,&flags) ) return PK_MEM;

  deflate();

  lm_free();
  ct_term();
  return PK_OK;
}
