#include <dir.h>
#include "../common.cpp"

//---------------------------------------------------------------------------
// create a directory with all required intermediate directories
void createdir(char *dir)
{
  const char delim = '\\';
  char *ptr = strchr(dir, delim);
  while ( ptr != NULL )
  {
    *ptr = '\0';
    mkdir(dir);
    *ptr = delim;
    ptr = strchr(ptr+1, delim);
  }
}

//------------------------------------------------------------------------
// ask a question and get one of three possible answers: yes/no/cancel
// returns:1-yes,0-no,-1-cancel
int vaskyn(int def, const char *format, va_list va)
{
  char buf[2*MAXSTR];
  wvsprintf(buf, format, va);
       if ( def < 0 ) def = MB_DEFBUTTON3;
  else if ( def > 0 ) def = MB_DEFBUTTON1;
  else                def = MB_DEFBUTTON2;
  switch ( MessageBox(NULL, buf, appname, def|MB_YESNOCANCEL|MB_ICONQUESTION) )
  {
    case IDYES:
      return 1;
    case IDNO:
      return 0;
  }
  return -1;
}

//------------------------------------------------------------------------
// ask a question and get one of three possible answers: yes/no/cancel
// returns:1-yes,0-no,-1-cancel
int askyn(int def, const char *format, ...)
{
  va_list va;
  va_start(va, format);
  int code = vaskyn(def, format, va);
  va_end(va);
  return code;
}


